#include "SPI.h"
#include "Wire.h"
#include "FT_VM801B43.h"
 
FT801IMPL_SPI FTImpl(FT_CS_PIN, FT_PDN_PIN, FT_INT_PIN);
 
boolean DisplayInit()
{
  uint32_t chipid = 0;
 
  Serial.println("Inicjalizacja ekranu");
 
  // Inicjalizujemy ekran
  FTImpl.Init(FT_DISPLAY_RESOLUTION);
 
  delay(20);
 
  // Pobieramy ID ukladu i sprawdzamy czy to FT800
  chipid = FTImpl.Read32(FT_ROM_CHIPID);
 
  if (chipid != FT801_CHIPID)
  {
    Serial.print("Nie obslugiwany uklad: 0x");
    Serial.println(chipid, HEX);
    return false;
  }
 
  Serial.print("Obslugiwany uklad: 0x");
  Serial.println(chipid, HEX);
 
  // Wlaczamy ekran
  FTImpl.DisplayOn();
 
  return true;
}
 
void scena(unsigned long int czas)
{
  FTImpl.DLStart(); // Otwieramy liste wyswietlania
 
  FTImpl.ColorRGB(0xFF, 0xFF, 0xFF); // Ustawiamy kolor bialy (R,G,B)
 
  // Wyswietlamy tekst w naroznikach
  // Parametry: x, y, rozmiar 16-31, centrowanie, tekst
  FTImpl.Cmd_Text(10, 10, 20, FT_OPT_CENTERY, "LEWO-GORA");
  FTImpl.Cmd_Text(FT_DISPLAYWIDTH - 10, 10, 20, FT_OPT_RIGHTX | FT_OPT_CENTERY, "PRAWO-GORA");
  FTImpl.Cmd_Text(10, FT_DISPLAYHEIGHT - 10, 20, FT_OPT_CENTERY, "LEWO-DOL");
  FTImpl.Cmd_Text(FT_DISPLAYWIDTH - 10, FT_DISPLAYHEIGHT - 10, 20, FT_OPT_RIGHTX | FT_OPT_CENTERY, "PRAWO-DOL");
 
  // Wyswietlamy napis na srodku
  FTImpl.ColorRGB(0xFF, 0xFF, 0x00); // Ustawiamy kolor zolty (R,G,B)
  FTImpl.Cmd_Text(FT_DISPLAYWIDTH / 2, FT_DISPLAYHEIGHT / 2 - 15, 29, FT_OPT_CENTER, "www.electronics-lab.com");
 
  // Wyswietlamy liczbe z parametru funkcji
  FTImpl.ColorRGB(0x00, 0xFF, 0x00); // Ustawiamy kolor zielony (R,G,B)
  FTImpl.Cmd_Number(FT_DISPLAYWIDTH / 2, FT_DISPLAYHEIGHT / 2 + 15, 29, FT_OPT_CENTER, czas);
 
  // Latajace hashe
  int offset1 = czas % FT_DISPLAYWIDTH;
  int offset2 = FT_DISPLAYWIDTH - offset1;
 
  FTImpl.ColorRGB(0x00, 0xFF, 0xFF); // Ustawiamy kolor turkusowy (R,G,B)
  FTImpl.Cmd_Text(offset1, FT_DISPLAYHEIGHT / 2 - 50, 31, FT_OPT_CENTER, "#");
  FTImpl.Cmd_Text(offset2, FT_DISPLAYHEIGHT / 2 + 50, 31, FT_OPT_CENTER, "#");
 
  FTImpl.DLEnd(); // Zamykamy liste wyswietlania
  FTImpl.Finish(); // Renderujemu liste i czekamy na ukonczenie
}
 
void setup()
{
  Serial.begin(9600);
 
  while (!DisplayInit()) {}
}
 
void loop()
{
  scena(millis());
}
